#!/usr/local/bin/perl
package NibbsMakeHTML;

########################################################
# makehtml HTML⥸塼
# @version 1.01
# @since 2001/10/02
# @author made bY NI-Lab.
########################################################
# history
# 2001.10.15 package NibbsMakeHTML Ȥɲ Ver. 1.01
# 2001.11.03 ǥåǽɲ Ver. 1.10
########################################################



&init;
#&set_file_name;
#&doit;



sub init {
########################################################
### HTMLե˴ؤ 
########################################################

### ڡ̾
$RETURN_PAGE_NAME = "NI-Lab.";

### URL
$RETURN_PAGE = "http://isweb13.infoseek.co.jp/computer/nilab/";

### ڡȥ
$PAGE_TITLE = "nibbs-log";

### å
$EXPLANATION = "ǼĤβå";

# ۿ
$BG_COLOR = "#ffbbbb";
$TEXT_COLOR = "#000000";
$LINK_COLOR = "#aa0000";
$VLINK_COLOR = "#aa00aa";
$ALINK_COLOR = "#ff0000";

# طʿ
$BG_RED = 255;
$BG_GREEN = 175;
$BG_BLUE = 175;

########################################################
### HTMLե˴ؤ ޤ
########################################################

	$VERSION = "1.10";

	# Field of a Record(ηѤȤѹ뤳)
	$RECORD_FIELDS = 14;

	$CANNOT_OPEN_FILE = "ե뤬ץǤޤ";

} # init ends...



sub set_file_name {
	$LOGFILE = shift; # ե̾
	$OUTFILE = shift; # ϥե̾
}



sub doit {
	@messages = printLog( $LOGFILE, $check ); # 
	if ( $check == 3 ) {
		&print_error_msg($CANNOT_OPEN_FILE); # 顼ɽ
		exit;
	}

	# եؽ񤭤
	open(OUTHANDLER, ">$OUTFILE") || return 3;
	&print_html(@messages);
	close(OUTHANDLER);

	return 0;
} # doit ends...



### HTMLǥåκ
sub print_htmlindex {

	local $indexfilename = shift; # ǥåեѥ
	local $htmlfiles = shift; # HTMLեο

	open(OUTHANDLER, ">$indexfilename") || return 3;

	&print_html_head;

print OUTHANDLER << "__EOS__";
<dl>
<dt> 
__EOS__

	local $filename;
	local $begin_number;

	for ( $i = 1; $i <= $htmlfiles; $i++ ) {
		$filename = $i . '.html';
		$begin_number = ($i - 1) * 100 + 1;
		if ( $i % 10 == 1 ) {
			print OUTHANDLER "<dd><a href=\"$filename\">$begin_number-</a>\n";
		}
		else {
			print OUTHANDLER "<a href=\"$filename\">$begin_number-</a>\n";
		}
	}

print OUTHANDLER << "__EOS__";
</dt>
</dl>
<hr>
__EOS__

	&print_html_foot;
	close(OUTHANDLER);

	return 0;
}



### HTMLκ
sub print_html {
	&print_html_head;
	&print_records(@_);
	&print_html_foot;
}



### HTMLΥإåʬɽ
sub print_html_head {
print OUTHANDLER << "__EOS__";
<html><head><title>$PAGE_TITLE</title></head>
<body bgcolor="$BG_COLOR" text="$TEXT_COLOR" link="$LINK_COLOR" vlink="$VLINK_COLOR" alink="$ALINK_COLOR">
<hr>
<div align=right><a href="$RETURN_PAGE">$RETURN_PAGE_NAME</a></div>
<font size=5>$PAGE_TITLE</font><br>
$EXPLANATION<br>
<hr>
__EOS__
}



### ֥롼 ҤȤɽ
sub print_one_record {
	local($count, $kind, $namae, $bunsho, $namex, $namey, $msgx, $msgy, $datetime, $red, $green, $blue, $fontsize, $ipadress) = @_;

print OUTHANDLER << "__EOS__";
No.$count  Name: <b> $namae </b>  $datetime <br>
<div style="color:rgb( $red, $green, $blue );">$bunsho</div>
<hr>
__EOS__
}



### HTMLΥեåʬɽ
sub print_html_foot {
print OUTHANDLER << "__EOS__";
<div align=right>This page is created by <a href="http://isweb13.infoseek.co.jp/computer/nilab/">NI-Lab.</a>'s makehtml $VERSION</div><br><br>
</body>
</html>
__EOS__
}



### ɽ
sub print_records {

	local(@one_record);
	local($target_no);

	for ($i = 0; $i < (@_ + 1) / $RECORD_FIELDS - 1; $i++) {

		$target_no = $RECORD_FIELDS * $i;

		for ($j = 0; $j < $RECORD_FIELDS; $j++) {
			push @one_record, $_[ $target_no + $j ];
		}

		&print_one_record(@one_record);

		for ($j = 0; $j < $RECORD_FIELDS; $j++ ) {
			pop @one_record;
		}

	}

} # sub print_records ends...




# 
# ɽ($loglines)0ꤹɽ
sub printLog {

	my ($logfilename,$check) = @_;
	local(@messages); # 

	# ե뤫ɤ߹
	local(@record);

	# ե򥪡ץ󤷤ɤ߹
	open(LOG, "<$logfilename") or $check = 3;
	if ( $check == 3 ) { return @message; }
	@record = <LOG>;
	close(LOG);

	local($count, $kind, $name, $msg, $namex, $namey, $msgx, $msgy, $datetime, $red, $green, $blue, $fontsize, $ipadress);

	foreach $one_record(@record)
	{
		($count, $kind, $name, $msg, $namex, $namey, $msgx, $msgy, $datetime, $red, $green, $blue, $fontsize, $ipadress) = split(/<>/,$one_record);

		# ҤȤĤεɽʬ
		$datetime = localtime $datetime;
		push @messages, ($count, $kind, $name, $msg, $namex, $namey, $msgx, $msgy, $datetime, $red, $green, $blue, $fontsize, $ipadress);
	}

	$check = 0;
	return @messages;
}


### 顼åɽ
sub print_error_msg {
print << "__EOS__";
<html>
<body>
$_[0]
</body>
</html>
__EOS__
}





1;

