#!/usr/local/bin/perl
require 'jcode.pl';
use NibbsLog;
require 'settings.pl';

###  Ū    ####################################

# ȥ
$PAGE_TITLE = 'nibbs-standard';

# ʸ
$EXPLANATION = 'nibbsѷǼĤǤʡ';

# HTMLե륤ǥåURL
$PAST_HTML_INDEX = 'html/index.html';

# ɽ
$LOG_LINES = 100;

# ۿ
$BG_COLOR = "#ffbbbb";
$TEXT_COLOR = "#000000";
$LINK_COLOR = "#aa0000";
$VLINK_COLOR = "#aa00aa";
$ALINK_COLOR = "#ff0000";

# طʿ
$BG_RED = 255;
$BG_GREEN = 175;
$BG_BLUE = 175;

###  Ū  ޤ  ####################################





###  ʲΥɤѲ¤뤳Ȥ餫ؤޤ(^^;) ##





###  ȯԸ    ##################################

# Error Messages
$ILLEGAL_INPUT_DATA = "ϤǤ";
$CANNOT_OPEN_FILE = "ե뤬ץǤޤ";

# kind
$KIND = "ST";

# Field of a Record(ηѤȤѹ뤳)
$RECORD_FIELDS = 14;

###  ȯԸ  ޤ  ##################################





###  ȯԸǥϥ롼    ########################



### HTMLɽ
sub print_html {
&print_html_head;
&print_records(@_);
&print_html_foot;
}



### HTMLΥإåʬɽ
sub print_html_head {
print << "__EOS__";
<html><head><title>$PAGE_TITLE</title></head>
<body bgcolor="$BG_COLOR" text="$TEXT_COLOR" link="$LINK_COLOR" vlink="$VLINK_COLOR" alink="$ALINK_COLOR">
<hr>
<div align=right><a href="$RETURN_PAGE">$RETURN_PAGE_NAME</a></div>
<font size=5>$PAGE_TITLE</font><br>
$EXPLANATION<br>
<form method="POST">
<input name="namae" size="20" maxsize="20">Name(It's Yours!)<br>
<textarea name="bunsho" cols="80" rows="5"></textarea>Message<br>
<input type="submit" value="񤭹">
</form>

<div align=right><table border=0>
<td>
	<form method="GET" action="$PAST_HTML_INDEX">
	<input type="submit" value="Past Messages">
	</form>
</td>
<td>
	<form method="POST">
	<input type="hidden" name="ni" value="lab">
	<input type="submit" value="Display All Log">
	</form>
</td>
</table></div>

<hr>
__EOS__
}



### ֥롼 ҤȤɽ
sub print_one_record {
	local($count, $kind, $namae, $bunsho, $namex, $namey, $msgx, $msgy, $datetime, $red, $green, $blue, $fontsize, $ipadress) = @_;

print << "__EOS__";
No.$count  Name: <b> $namae </b>  $datetime <br>
<div style="color:rgb( $red, $green, $blue );">$bunsho</div>
<hr>
__EOS__
}



### HTMLΥեåʬɽ
sub print_html_foot {
print << "__EOS__";
<div align=right>nibbs-standard $VERSION  produceD bY <a href="$AUTHOR_URL">NI-Lab.</a></div><br><br>
</body>
</html>
__EOS__
}





### 顼åɽ
sub print_error_msg {
print << "__EOS__";
<html>
<body>
$_[0]
</body>
</html>
__EOS__
}



###  ȯԸǥϥ롼  ޤ  ########################





### main start ######################################################

# إå
print "Content-type: text/html\n\n";


# Ͻ
# MagicNumber¿ʤ
if ($ENV{REQUEST_METHOD} eq "POST") {

	$check = NibbsLog->writeFormData( $KIND, $LOGFILE, $LOCKFILE, $BG_RED, $BG_GREEN, $BG_BLUE);

	if ( $check == 1 ) {
		# ɽ
		@messages = NibbsLog->printLog( $KIND, $LOGFILE, $LOCKFILE, 0, $check ); # ɽ
		if ( $check == 3 ) {
			&print_error_msg($CANNOT_OPEN_FILE); # 顼ɽ
			exit;
		}
		&print_html(@messages);
		exit;
	}
	elsif ( $check == 2 ) {
		&print_error_msg($ILLEGAL_INPUT_DATA); # 顼ɽ
		exit;
	}
	elsif ( $check == 3 ) {
		&print_error_msg($CANNOT_OPEN_FILE); # 顼ɽ
		exit;
	}
}



# GET
@messages = NibbsLog->printLog( $KIND, $LOGFILE, $LOCKFILE, $LOG_LINES, $check ); # 
if ( $check == 3 ) {
	&print_error_msg($CANNOT_OPEN_FILE); # 顼ɽ
	exit;
}
&print_html(@messages);



exit; # λ

### main ends... ####################################################





### ɽ
sub print_records {

	local(@one_record);
	local($target_no);

	for ($i = 0; $i < (@_ + 1) / $RECORD_FIELDS - 1; $i++) {

		$target_no = $RECORD_FIELDS * $i;

		for ($j = 0; $j < $RECORD_FIELDS; $j++) {
			push @one_record, $_[ $target_no + $j ];
		}

		&print_one_record(@one_record);

		for ($j = 0; $j < $RECORD_FIELDS; $j++ ) {
			pop @one_record;
		}

	}

} # sub print_records ends...





